SystemOrganization addCategory: #'JQWidgetBox-TimeSlider-Core'!

!JQueryInstance methodsFor: '*jqwidgetbox-timeslider-core' stamp: 'PaulDeBruicker 6/26/2011 11:31'!
timeSlider
	^self create: JQTimeSlider ! !

JQWidget subclass: #JQTimeSlider
	instanceVariableNames: 'sliderOptionsDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-TimeSlider-Core'!

!JQTimeSlider commentStamp: 'PaulDeBruicker 6/29/2011 13:43' prior: 0!
Be sure to put #sliderOptions at the end of the cascade or else they won't get set.  

this adapts the jQuery UI Slider to display and return times rather than values.  It is based on the code here:  

https://github.com/marcneuwirth/jquery.ui.timeslider
as described here:
http://marcneuwirth.com/blog/2011/05/22/revisiting-the-jquery-ui-time-slider/
and:
http://marcneuwirth.com/blog/2010/02/21/using-a-jquery-ui-slider-to-select-a-time-range/

my adaptations are stored here:
https://github.com/pdebruic/jquery.ui.timeslider



but I adapted it some to be able to have separate text inputs when using a range.    I did  not "fix" the fact that the timeSlider javascript library overrides the onStop: , onChange: , onSlide: and onStart: methods   


12:00AM is represented by a slider value of 300 because the timeslider javascript library uses the Date() object but does not retain or use date or timezone information.  11:59 PM is represented by a slider value of 1739. 

I do not know but guess that the time offset should be different based on what time zone you run this in.  

 Each point in between is a minute.  So 1739-300 = 1439 and there are 1440 minutes in a 24 hr period.  clicking the submit buttons just returns the strings displayed in the text input boxes.  
!

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:21'!
animate: aBoolean
	sliderOptionsDict at: 'animate' put: aBoolean! !

!JQTimeSlider methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2011 10:38'!
clickSubmit: aFunction
"clickSubmit: The function that will be executed when the submitButton is clicked"
self optionAt:  'clickSubmit' put: aFunction   
! !

!JQTimeSlider methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/26/2011 18:21'!
disabled: aBoolean
	sliderOptionsDict at: 'disabled' put: aBoolean! !

!JQTimeSlider methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/26/2011 16:02'!
endTime: aSelector
"	endTime: Selector for the element that will contain the current selected time if using one value or the first value if using a range."
	self optionAt:  'endTime' put: aSelector    ! !

!JQTimeSlider methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2011 10:35'!
errorMessage: aSelector
"errorMessage: Selector for the element that will contain the error message if the range is over 24 hours"
self optionAt:  'errorMessage' put:    aSelector ! !

!JQTimeSlider methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/26/2011 13:32'!
initialize 
	super initialize.
	sliderOptionsDict :=SmallDictionary new.! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:16'!
max: aNumberOfMinutes
	sliderOptionsDict at: 'max' put: aNumberOfMinutes ! !

!JQTimeSlider methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2011 10:33'!
method
	^'timeslider'! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:22'!
min: aNumberOfMinutes
	sliderOptionsDict at: 'min' put: aNumberOfMinutes ! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:20'!
onChange: anObject
	"this is over ridden by the timeSlider js"! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:20'!
onSlide: anObject
	"this is over ridden by the timeSlider js"! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:20'!
onStart: anObject
	"this is over ridden by the timeSlider js"! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:21'!
onStop: anObject
	"this is over ridden by the timeSlider js"! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 13:27'!
orientation: anOrientation
	sliderOptionsDict at: 'orientation' put: anOrientation ! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:19'!
range: aBoolean
	sliderOptionsDict at: 'range' put: aBoolean ! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:19'!
rangeMax: aNumberOfMinutes
	self optionAt:  'rangeMax' put:   aNumberOfMinutes ! !

!JQTimeSlider methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/26/2011 17:22'!
setValueFrom: aSmallIntegerOrTime
	^ aSmallIntegerOrTime className = 'SmallInteger'
		ifTrue: [ aSmallIntegerOrTime ]
		ifFalse: [ self valueFromTime: aSmallIntegerOrTime ]! !

!JQTimeSlider methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/26/2011 13:34'!
sliderOptions
"sliderOptions: use this to set the default jQuery UI slider options"


	self optionAt:  'sliderOptions' put:  (JsonObject fromAssociations: sliderOptionsDict associations)  
	! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/29/2011 13:49'!
start: aSmallIntegerOrTime
|start|
"Use this for a one handled slider"
start:=self setValueFrom:   aSmallIntegerOrTime.


self range:false.
self value:start! !

!JQTimeSlider methodsFor: 'accessing' stamp: 'PaulDeBruicker 6/29/2011 13:21'!
start: aSmallIntegerOrTime end: aSmallIntegerOrTime2
|start end|
"use this for a range slider"
start:=self setValueFrom:   aSmallIntegerOrTime.
end:=self setValueFrom:  aSmallIntegerOrTime2.

self range: true.
self values: (Array with: start with: end)! !

!JQTimeSlider methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/26/2011 16:02'!
startTime: aSelector
"	startTime: Selector for the element that will contain the current selected time if using one value or the first value if using a range."
	self optionAt:  'startTime' put: aSelector    ! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:24'!
step: aNumberOfMinutes
	sliderOptionsDict at: 'step' put: aNumberOfMinutes! !

!JQTimeSlider methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 6/25/2011 10:37'!
submitButton: aSelector
"submitButton: Selector for the element that will act as submit Button"
self optionAt:  'submitButton' put:    aSelector ! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 13:28'!
value: anOrientation
	sliderOptionsDict at: 'value' put: anOrientation ! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 18:58'!
valueFromTime: aTime
	^ aTime asSeconds // 60 +300! !

!JQTimeSlider methodsFor: 'sliderOptions' stamp: 'PaulDeBruicker 6/26/2011 16:59'!
values: anArray
	sliderOptionsDict at: 'values' put: anArray ! !

!JQWidgetBoxDeploymentLibrary methodsFor: '*jqwidgetbox-timeslider-core' stamp: 'PaulDeBruicker 6/29/2011 13:15'!
jqueryuitimesliderminJs
	^ '(function(a){a.widget("ui.timeslider",{getTime:function(d){var e=null,f=new Date(d*60*1000),c=f.getMinutes(),b=f.getHours();if(b===0){b=12}if(b>12){b=b-12;e="PM"}else{e="AM"}if(c<10){c="0"+c}return b+":"+c+" "+e},_slideTime:function(e,f){var d=a(this),b=null,c=null;if(d.slider("option","range")){b=d.timeslider("getTime",(d.slider("values",0)));c=d.timeslider("getTime",d.slider("values",1));d.timeslider("option","startTime").val(b);d.timeslider("option","endTime").val(c)}else{b=d.timeslider("getTime",d.slider("value"));d.timeslider("option","startTime").val(b)}},_checkMax:function(d,e){var c=a(this);if(c.slider("option","range")){var f=c.find("div"),b=c.slider("values",1)-c.slider("values",0);if(b>=1435){f.addClass("ui-state-error");c.timeslider("option","submitButton").attr("disabled","disabled").addClass("ui-state-disabled");c.timeslider("option","errorMessage").text("Cannot be more than 24 hours")}else{f.removeClass("ui-state-error");c.timeslider("option","submitButton").attr("disabled",null).removeClass("ui-state-disabled");c.timeslider("option","errorMessage").text("")}}},options:{sliderOptions:{},errorMessage:null,startTime:null,endTime:null,submitButton:null,clickSubmit:null},_create:function(){var c=this,d=c.options,b=c.element;d.sliderOptions.slide=c._slideTime;d.sliderOptions.change=c._checkMax;d.sliderOptions.stop=c._slideTime;b.slider(d.sliderOptions);d.errorMessage=a(d.errorMessage);d.endTime=a(d.endTime);d.startTime=a(d.startTime);d.submitButton=a(d.submitButton).click(d.clickSubmit);c._slideTime.call(b)},_destroy:function(){this.element.remove()}})})(jQuery);'! !
